;==================================================
; Stalking Goomba
; By Erik
;
; Description: This Goomba will follow Mario all
; the level, kind of like a Phanto but you don't
; need to be holding a key.
;=================================================

goomba_tiles:
        db $A8,$AA
goomba_wing_tiles:
        db $C6,$C6,$5D,$5D
goomba_wing_props:
        db $46,$06

x_acceleration:
        db $02,-$02
y_acceleration:
        db $02,-$02
max_x_speeds:
        db $28,-$28
max_y_speeds:
        db $18,-$18

;--- 

print "MAIN ",pc
        LDA !9E,x
        CMP #$0F
        BNE +
        LDA #$00
        STA !7FAB10,x
        RTL
+       PHB
        PHK
        PLB
        JSR following_goomba
        PLB
print "INIT ",pc
        RTL

following_goomba:
        JSR draw_sprite
        LDA !14C8,x             ;\
        EOR #$08                ; | if sprite state not normal
        ORA $9D                 ; | or if sprites locked, return
        BNE return              ;/

        INC !1570,x
        INC !1570,x
        INC !C2,x
        LDA !C2,x
        LSR #3
        AND #$01
        STA !1602,x

        LDA $14                 ;\
        AND #$03                ; | only change speeds every fourth frame
        BNE apply_speed         ;/
        %SubHorzPos()           ;\
        TYA
        STA !157C,x             
        LDA !sprite_speed_x,x   ; | if max horizontal speed in the appropriate
        CMP max_x_speeds,y      ; | direction achieved, don't change horizontal speed
        BEQ max_x_reached       ;/  
        CLC                     ;\
        ADC x_acceleration,y    ; | else, accelerate in appropriate direction
        STA !sprite_speed_x,x   ;/
max_x_reached:
        %SubVertPos()           ;\
        LDA !sprite_speed_y,x   ; | if max vertical speed in the appropriate
        CMP max_y_speeds,y      ; | direction achieved, don't change vertical speed
        BEQ apply_speed         ;/
        CLC                     ;\
        ADC y_acceleration,y    ; | else, accelerate in appropriate direction
        STA !sprite_speed_y,x   ;/
apply_speed:
        JSL $018022|!BankB      ;   apply x speed
        JSL $01801A|!BankB      ;   apply y speed
        JSL $01A7DC|!BankB
return:
        RTS

;--- 

goomba_wing_x_disp:
        db $F7,$0B,$F6,$0D,$FD,$0C,$FC,$0D
        db $0B,$F5,$0A,$F3,$0B,$FC,$0C,$FB
goomba_wing_y_disp:
        db $F7,$F7,$F8,$F8,$01,$01,$02,$02
goomba_wing_tilesize:
        db $02,$02,$00,$00

draw_sprite:
        %GetDrawInfo()
        LDA !1570,x
        LSR #2
        AND #$02
        CLC
        ADC !1602,x
        STA $05
        ASL
        STA $02
        LDA !157C,x
        STA $04

        LDX #$01
.wings_loop
        STX $03
        TXA
        CLC
        ADC $02
        PHA
        LDX $04
        BNE +
        CLC
        ADC #$08
+       TAX
        LDA $00
        CLC
        ADC goomba_wing_x_disp,x
        STA $0300|!Base2,y
        PLX
        LDA $01
        CLC
        ADC goomba_wing_y_disp,x
        STA $0301|!Base2,y
        LDX $05
        LDA goomba_wing_tiles,x
        STA $0302|!Base2,y
        PHY
        TYA
        LSR #2
        TAY
        LDA goomba_wing_tilesize,x
        STA $0460|!Base2,y
        PLY
        LDX $03
        LDA $04
        LSR
        LDA goomba_wing_props,x
        BCS +
        EOR #$40
+       ORA $64
        STA $0303|!Base2,y
        TYA
        CLC
        ADC #$08
        TAY
        DEX
        BPL .wings_loop
        LDX $15E9|!Base2
        LDA !15EA,x
        CLC
        ADC #$04
        TAY

        LDA $00                 ;   set x position of the tile
        STA $0300|!Base2,y
        LDA $01                 ;   set y position of the tile
        STA $0301|!Base2,y

        LDA $04
        LSR
        LDA !15F6,x             ;   get sprite palette info
        BCS +
        EOR #$40
+       ORA $64                 ;   add in the priority bits from the level settings
        STA $0303|!Base2,y      ;   set properties

        LDA !1602,x
        TAX
        LDA goomba_tiles,x
        STA $0302|!Base2,y
        LDX $15E9|!Base2
        TYA
        LSR #2
        TAY
        LDA #$02
        STA $0460|!Base2,y
        LDY #$FF                ;   the tiles drawn were 16x16
        LDA #$03                ;   one tile was drawn
        JSL $01B7B3|!BankB      ;   finish OAM write
        RTS

